// Filename           : CLICTD_pins_comparator.sv
// Author             : Núria Egidos 
// Created on         : 12/6/18
// Last modification  : 27/9/18
// Project            : Doctoral student, verification of CLICTD
// Description        : Comparator

`ifndef __CLICTD_pins_comparator_sv__
`define __CLICTD_pins_comparator_sv__

//import uvm_pkg::*;
//`include <uvm_macros.svh>

// This comparator assumes in-order arrival of transactions, i.e. the order of 
// arrival of a transaction from the predictor/golden model matches the order of 
// arrival of a transaction generated by the monitor probing the outputs


// This structure will enable having more than one export in the same scoreboard; 
// when the respective anlaysis ports call write(), the factory will automatically invoke 
// write_ideal() for the export associated to the port probing the expected outputs from the
// golden model, or write_actual() for the export associated to the port probing the actual
// outputs, depending on which of the ports is calling
//`uvm_analysis_imp_decl(_ideal)
//`uvm_analysis_imp_decl(_actual)




class CLICTD_pins_comparator extends CLICTD_comparator;
	`uvm_component_utils(CLICTD_pins_comparator) // Register the component to the factory


  CLICTDevents events_obj;


	// Declaration of the export used to connect to the analysis port in the agent
  // (to probe the outputs or internal signals of the DUT)
  uvm_analysis_export #(CLICTD_pins_transaction) analysis_export_actual;
  // Declaration of the export used to connect to the analysis port in the golden 
  // model (to probe the expected outputs)
  uvm_analysis_export #(CLICTD_pins_transaction) analysis_export_ideal;


  // Declaration of the fifos used to collect the streams of transactions
  // coming from the analysis ports, so as to synchronise them to 
  // be able to compare them:
  // For the transactions coming from the golden model (to probe ideal outputs)
  uvm_tlm_analysis_fifo #(CLICTD_pins_transaction) ideal_fifo;
  // For the transactions coming from the agent (to probe actual outputs)
  uvm_tlm_analysis_fifo #(CLICTD_pins_transaction) actual_fifo;


	// - - - - - - - - - - - - Constructor
	function new(string name, uvm_component parent);
		super.new(name, parent);
	endfunction: new


  // - - - - - - - - - - - - Build phase: build the hierarchy
	function void build_phase(uvm_phase phase);
		super.build_phase(phase);
    
    // Create the exports
		analysis_export_actual = new("analysis_export_actual", this);
		analysis_export_ideal = new("analysis_export_ideal", this);
		// Create the FIFOs
  	actual_fifo = new("actual_fifo", this);
		ideal_fifo = new("ideal_fifo", this);

    if( !uvm_config_db#(CLICTDevents)::get(this, "", "events_obj", events_obj) )
         `uvm_error( `NOCLICTDEVENTS, $sformatf("CLICTDevents not found in database for %s", this.get_full_name()) )
    

	endfunction: build_phase


	
  // - - - - - - - - - - - - Connect phase: connect FIFOs and exports
	function void connect_phase(uvm_phase phase);
    super.connect_phase(phase);
    analysis_export_actual.connect(actual_fifo.analysis_export);
		analysis_export_ideal.connect(ideal_fifo.analysis_export);
                                     
	endfunction: connect_phase


  // - - - - - - - - - - - - Run phase: here is where the transactions are retrieved from the 
  // exports, stored temporarily in the FIFOs to synchronise and then
  // retrieved from the FIFOs to compare them
	task run();

    number_transactions_evaluated[STATUS_RESET] = 0;
    number_transactions_evaluated[STATUS_SECOND_READOUT_ALL_ZEROS] = 0;
    number_transactions_evaluated[STATUS_CONFIG_READOUT_SECOND_HALF] = 0;
    number_transactions_evaluated[STATUS_POWERPULSE_EXTERNAL_WORKING] = 0;
    number_transactions_evaluated[STATUS_POWERPULSE_EXTERNAL_NOTHING_HAPPENS] = 0;
    number_transactions_evaluated[STATUS_POWERPULSE_INTERNAL_WORKING] = 0;
    number_transactions_evaluated[STATUS_POWERPULSE_INTERNAL_NOTHING_HAPPENS] = 0;
				number_transactions_evaluated[STATUS_TESTPULSE_EXTERNAL_WORKING] = 0;
				number_transactions_evaluated[STATUS_TESTPULSE_EXTERNAL_NOTHING_HAPPENS] = 0;
				number_transactions_evaluated[STATUS_TESTPULSE_INTERNAL_WORKING] = 0;
				number_transactions_evaluated[STATUS_TESTPULSE_INTERNAL_NOTHING_HAPPENS] = 0;
   
    fork		
        // Obtain transactions from the model and from the monitor and compare them 
			    	pinscomparator_action();
        // Detect timeout when waiting for an update in powerEnable
        timeout_action_powerEnable();
								// Detect timeout when waiting for an update in discTp
								timeout_action_discTp();
    join_none
    
    // The fork join_none is used to avoid that this forever begin blocks the execution of other 
   // run_phase tasks in the hierarchy
	endtask: run


  // - - - - - - - - - - - - Other tasks
  //
  // Compare the incoming transactions. This function is declared virtual so that 
  // if some other comparator is extended from this one, the child comparator can 
  // override this method, and when the method is called, the child version will be executed
	virtual function void compare(CLICTD_pins_transaction pins_transaction_ideal, CLICTD_pins_transaction pins_transaction_actual);
           bit comparison_result = pins_transaction_ideal.compare(pins_transaction_actual);
		         number_transactions_evaluated[chip_status_obj.chip_status] =  number_transactions_evaluated[chip_status_obj.chip_status] + 1;
           if (number_transactions_evaluated[chip_status_obj.chip_status] == 1) number_discrepancies[chip_status_obj.chip_status] = 0; // there will only be discrepancies if some transaction has been evaluated
           

           if (chip_status_obj.chip_status == STATUS_RESET) begin: status_reset

               if ( comparison_result ) begin
                  `uvm_info("compare", $sformatf(":) columnDone, dataIn and commonToken have the expected value for chip_status: %s", chip_status_obj.chip_status), UVM_LOW)
               end
               else begin
                    if ( pins_transaction_ideal.fields_with_error.exists(COLUMNDONE) ) begin
				               `uvm_info("compare", $sformatf(":( columnDone does NOT have the expected value for chip_status: %s", chip_status_obj.chip_status), UVM_LOW)
				            end
				            if ( pins_transaction_ideal.fields_with_error.exists(DATAIN) ) begin
				               `uvm_info("compare", $sformatf(":( dataIn does NOT have the expected value for chip_status: %s", chip_status_obj.chip_status), UVM_LOW)
				            end
				            if ( pins_transaction_ideal.fields_with_error.exists(COMMONTOKEN) ) begin
				               `uvm_info("compare", $sformatf(":( commonToken does NOT have the expected value for chip_status: %s", chip_status_obj.chip_status), UVM_LOW)
				            end
                    increment_number_discrepancies(); 
               end

           end: status_reset

           else if (chip_status_obj.chip_status == STATUS_CONFIG_READOUT_SECOND_HALF) begin: status_config

               if ( comparison_result ) begin
              		`uvm_info("compare", $sformatf(":) tpEnableDigital, mask, tpEnableAnalog and tuningDAC0-7 have the expected value for chip_status: %s", chip_status_obj.chip_status), UVM_LOW);
																/*
																for (int c = 0; c < `COLUMNS; c++) begin
																					for (int ss = 0; ss < `SUPERPIXEL_SEGMENTS; ss++) begin
						    															for (int sis = 0; sis < `SUPERPIXELS_IN_ONE_SEGMENT; sis++) begin
																														$display("DISPLAY - pins comparator - c %0d, ss %0d, sis %0d, EXPECTED: tpEnableDigital = %b, mask = %h, tpEnableAnalog = %h, tuningDAC0 = %h, tuningDAC1 = %h, tuningDAC2 = %h, tuningDAC3 = %h, tuningDAC4 = %h, tuningDAC5 = %h, tuningDAC6 = %h, tuningDAC7 = %h\n MEASURED: tpEnableDigital = %b, mask = %h, tpEnableAnalog = %h, tuningDAC0 = %h, tuningDAC1 = %h, tuningDAC2 = %h, tuningDAC3 = %h, tuningDAC4 = %h, tuningDAC5 = %h, tuningDAC6 = %h, tuningDAC7 = %h", 
                               c, ss,sis,
																															pins_transaction_ideal.tpEnableDigital[c][ss][sis], pins_transaction_ideal.mask[c][ss][sis], pins_transaction_ideal.tpEnableAnalog[c][ss][sis], pins_transaction_ideal.tuningDAC0[c][ss][sis],
																															pins_transaction_ideal.tuningDAC1[c][ss][sis], pins_transaction_ideal.tuningDAC2[c][ss][sis], pins_transaction_ideal.tuningDAC3[c][ss][sis], pins_transaction_ideal.tuningDAC4[c][ss][sis],
																															pins_transaction_ideal.tuningDAC5[c][ss][sis], pins_transaction_ideal.tuningDAC6[c][ss][sis], pins_transaction_ideal.tuningDAC7[c][ss][sis],
																															pins_transaction_actual.tpEnableDigital[c][ss][sis], pins_transaction_actual.mask[c][ss][sis], pins_transaction_actual.tpEnableAnalog[c][ss][sis], pins_transaction_actual.tuningDAC0[c][ss][sis],
																															pins_transaction_actual.tuningDAC1[c][ss][sis], pins_transaction_actual.tuningDAC2[c][ss][sis], pins_transaction_actual.tuningDAC3[c][ss][sis], pins_transaction_actual.tuningDAC4[c][ss][sis],
																															pins_transaction_actual.tuningDAC5[c][ss][sis], pins_transaction_actual.tuningDAC6[c][ss][sis], pins_transaction_actual.tuningDAC7[c][ss][sis]);
																									end
																					end
																end
                */
						
																
               end
               else begin

						        if ( pins_transaction_ideal.fields_with_error.exists(TPENABLEDIGITAL) ) begin
						            `uvm_info("compare", $sformatf(":( tpEnableDigital %b does NOT have the expected value %b for chip_status: %s", pins_transaction_actual.tpEnableDigital,pins_transaction_ideal.tpEnableDigital,chip_status_obj.chip_status), UVM_LOW)
						        end
						        if ( pins_transaction_ideal.fields_with_error.exists(MASK) ) begin
						            `uvm_info("compare", $sformatf(":( mask %h does NOT have the expected value %h for chip_status: %s", pins_transaction_actual.mask,pins_transaction_ideal.mask,chip_status_obj.chip_status), UVM_LOW)
						        end 
						        if ( pins_transaction_ideal.fields_with_error.exists(TPENABLEANALOG) ) begin
						            `uvm_info("compare", $sformatf(":( tpEnableAnalog %h does NOT have the expected value %h for chip_status: %s", pins_transaction_actual.tpEnableAnalog,pins_transaction_ideal.tpEnableAnalog,chip_status_obj.chip_status), UVM_LOW)
						        end
						        if ( pins_transaction_ideal.fields_with_error.exists(TUNINGDAC0) ) begin
						            `uvm_info("compare", $sformatf(":( tuningDAC0 %h does NOT have the expected value %h for chip_status: %s", pins_transaction_actual.tuningDAC0,pins_transaction_ideal.tuningDAC0,chip_status_obj.chip_status), UVM_LOW)
						        end
						        if ( pins_transaction_ideal.fields_with_error.exists(TUNINGDAC1) ) begin
						            `uvm_info("compare", $sformatf(":( tuningDAC1 %h does NOT have the expected value %h for chip_status: %s", pins_transaction_actual.tuningDAC1,pins_transaction_ideal.tuningDAC1,chip_status_obj.chip_status), UVM_LOW)
						        end
						        if ( pins_transaction_ideal.fields_with_error.exists(TUNINGDAC2) ) begin
						            `uvm_info("compare", $sformatf(":( tuningDAC2 %h does NOT have the expected value %h for chip_status: %s", pins_transaction_actual.tuningDAC2,pins_transaction_ideal.tuningDAC2,chip_status_obj.chip_status), UVM_LOW)
						        end
						        if ( pins_transaction_ideal.fields_with_error.exists(TUNINGDAC3) ) begin
						            `uvm_info("compare", $sformatf(":( tuningDAC3 %h does NOT have the expected value %h for chip_status: %s", pins_transaction_actual.tuningDAC3,pins_transaction_ideal.tuningDAC3,chip_status_obj.chip_status), UVM_LOW)
						        end
						        if ( pins_transaction_ideal.fields_with_error.exists(TUNINGDAC4) ) begin
						            `uvm_info("compare", $sformatf(":( tuningDAC4 %h does NOT have the expected value %h for chip_status: %s", pins_transaction_actual.tuningDAC4,pins_transaction_ideal.tuningDAC4,chip_status_obj.chip_status), UVM_LOW)
						        end
						        if ( pins_transaction_ideal.fields_with_error.exists(TUNINGDAC5) ) begin
						            `uvm_info("compare", $sformatf(":( tuningDAC5 %h does NOT have the expected value %h for chip_status: %s", pins_transaction_actual.tuningDAC5,pins_transaction_ideal.tuningDAC5,chip_status_obj.chip_status), UVM_LOW)
						        end
						        if ( pins_transaction_ideal.fields_with_error.exists(TUNINGDAC6) ) begin
						            `uvm_info("compare", $sformatf(":( tuningDAC6 %h does NOT have the expected value %h for chip_status: %s", pins_transaction_actual.tuningDAC6,pins_transaction_ideal.tuningDAC6,chip_status_obj.chip_status), UVM_LOW)
						        end
						        if ( pins_transaction_ideal.fields_with_error.exists(TUNINGDAC7) ) begin
						            `uvm_info("compare", $sformatf(":( tuningDAC7 %h does NOT have the expected value %h for chip_status: %s", pins_transaction_actual.tuningDAC7,pins_transaction_ideal.tuningDAC7,chip_status_obj.chip_status), UVM_LOW)
						        end
                    increment_number_discrepancies(); 
              end
               

           end: status_config

           else if ( chip_status_obj.chip_status == STATUS_POWERPULSE_EXTERNAL_WORKING || chip_status_obj.chip_status == STATUS_POWERPULSE_EXTERNAL_NOTHING_HAPPENS ||
                     chip_status_obj.chip_status == STATUS_POWERPULSE_INTERNAL_WORKING || chip_status_obj.chip_status == STATUS_POWERPULSE_INTERNAL_NOTHING_HAPPENS ) begin: status_powerpulse
                //$display("%t pins comparator - power enable = %h/%h, counter = %d/%d",$realtime,pins_transaction_ideal.powerEnable,
                // pins_transaction_actual.powerEnable,pins_transaction_ideal.counter_clk100gated_while_powerEnable_is_low,pins_transaction_actual.counter_clk100gated_while_powerEnable_is_low);
                if ( comparison_result ) begin
                  if (pins_transaction_ideal.powerEnable) begin
												         `uvm_info("compare", $sformatf(":) powerEnable has the expected value and CLK_100_GATED has been active for chip_status: %s", chip_status_obj.chip_status), UVM_LOW);	
                  end
                  else begin
              					   `uvm_info("compare", $sformatf(":) powerEnable has the expected value for chip_status: %s", chip_status_obj.chip_status), UVM_LOW);	
								         	end
                end
                else begin
                     if ( pins_transaction_ideal.fields_with_error.exists(POWERENABLE) )  begin
						                  `uvm_info("compare", $sformatf(":( powerEnable does NOT have the expected value for chip_status: %s", chip_status_obj.chip_status), UVM_LOW)
                     end
                     if ( pins_transaction_ideal.fields_with_error.exists(COUNTER_CLK100GATED) )  begin
						                  `uvm_info("compare", $sformatf(":( CLK_100_GATED was NOT active while powerEnable was low for chip_status: %s", chip_status_obj.chip_status), UVM_LOW)
                     end
                    increment_number_discrepancies(); 
                end
           end: status_powerpulse
											
											
											else if ( chip_status_obj.chip_status == STATUS_TESTPULSE_EXTERNAL_WORKING || chip_status_obj.chip_status == STATUS_TESTPULSE_EXTERNAL_NOTHING_HAPPENS ||
                     chip_status_obj.chip_status == STATUS_TESTPULSE_INTERNAL_WORKING || chip_status_obj.chip_status == STATUS_TESTPULSE_INTERNAL_NOTHING_HAPPENS ) begin: status_testpulse
                 if ( comparison_result ) begin
                     `uvm_info("compare", $sformatf(":) discTp has the expected value for chip_status: %s", chip_status_obj.chip_status), UVM_LOW);	
                	end
                	else if ( pins_transaction_ideal.fields_with_error.exists(DISCTP) )  begin
						               `uvm_info("compare", $sformatf(":( discTp does NOT have the expected value for chip_status: %s", chip_status_obj.chip_status), UVM_LOW)	
                    	increment_number_discrepancies(); 
                	end
           end: status_testpulse

           // Free the record of errors for the next comparison
           pins_transaction_ideal.fields_with_error.delete();


           // This event is used to indicate when to finish the sequence CLICTD_startstop_external_powerpulse_sequence. For STATUS_POWERPULSE_EXTERNAL_WORKING, 
           // we know that 3 transactions are to be handled, so when this number is reached, we can stop the sequence. This is required because a delay is to be introduced
           // afterwards, and if the sequence is not stopped, the delay may occur "in parallel" and lead to triggering timeouts that shouldn't happen
           //if ( number_transactions_evaluated[chip_status_obj.chip_status] == 3  && chip_status_obj.chip_status == STATUS_POWERPULSE_EXTERNAL_WORKING )
           //    events_obj.finish_sequence_power_pulsing_event.trigger(); 
		
	endfunction: compare
  //
  task pinscomparator_action();
       CLICTD_pins_transaction pins_transaction_ideal, pins_transaction_actual, aux_pins_transaction_ideal, aux_pins_transaction_actual;
       forever begin
          aux_pins_transaction_ideal = CLICTD_pins_transaction::type_id::create(.name("aux_pins_transaction_ideal"), .contxt(get_full_name()));
          aux_pins_transaction_actual = CLICTD_pins_transaction::type_id::create(.name("aux_pins_transaction_actual"), .contxt(get_full_name()));
          //pins_transaction_ideal = CLICTD_pins_transaction::type_id::create(.name("pins_transaction_ideal"), .contxt(get_full_name()));
          //pins_transaction_actual = CLICTD_pins_transaction::type_id::create(.name("pins_transaction_actual"), .contxt(get_full_name()));
					     actual_fifo.get(aux_pins_transaction_actual);
					     ideal_fifo.get(aux_pins_transaction_ideal);
          assert($cast( pins_transaction_ideal, aux_pins_transaction_ideal.clone() ));
          assert($cast( pins_transaction_actual, aux_pins_transaction_actual.clone() ));
										assert_isunknown_pins_transaction ( .pins_transaction(pins_transaction_ideal), .chip_status_obj(chip_status_obj), .name_of_transaction("pins_transaction_ideal"), .name_of_calling_component(this.get_full_name()) );
										assert_isunknown_pins_transaction ( .pins_transaction(pins_transaction_actual), .chip_status_obj(chip_status_obj), .name_of_transaction("pins_transaction_actual"), .name_of_calling_component(this.get_full_name()) );
										
          //`uvm_info("Retrieved from FIFOs", $sformatf("Transaction from pins_agent/pins_model, chip_status = %s",chip_status_obj.chip_status),  UVM_LOW)
          //if (chip_status_obj.chip_status == STATUS_POWERPULSE_EXTERNAL_WORKING || chip_status_obj.chip_status == STATUS_POWERPULSE_EXTERNAL_NOTHING_HAPPENS ||
          //    chip_status_obj.chip_status == STATUS_POWERPULSE_INTERNAL_WORKING || chip_status_obj.chip_status == STATUS_POWERPULSE_INTERNAL_NOTHING_HAPPENS)
              //$display("%t Retrieved from FIFOs - actual power enable = %h, ideal power enable = %h, clk gated counter = %d",
														//         $realtime,pins_transaction_actual.powerEnable,pins_transaction_ideal.powerEnable,pins_transaction_ideal.counter_clk100gated_while_powerEnable_is_low);
					     compare( pins_transaction_ideal, pins_transaction_actual );
				end
  endtask: pinscomparator_action
  //
  // Handle a timeout occured when waiting for an update in powerEnable
  task timeout_action_powerEnable();
       forever begin
                 //$display("%t waiting for timeout pins comparator",$realtime);
				         events_obj.timeout_update_powerenable_event.wait_trigger();
				         //events_obj.timeout_update_powerenable_event.reset();
             if ( chip_status_obj.chip_status == STATUS_POWERPULSE_EXTERNAL_WORKING || chip_status_obj.chip_status == STATUS_POWERPULSE_EXTERNAL_NOTHING_HAPPENS ||
                  chip_status_obj.chip_status == STATUS_POWERPULSE_INTERNAL_WORKING || chip_status_obj.chip_status == STATUS_POWERPULSE_INTERNAL_NOTHING_HAPPENS) begin
								         `uvm_info("compare", $sformatf(":( Timeout condition for powerEnable update, chip_status: %s", chip_status_obj.chip_status), UVM_LOW);
				           			if ( !number_discrepancies.exists(chip_status_obj.chip_status) ) number_discrepancies[chip_status_obj.chip_status] = 1;
				              else increment_number_discrepancies();
                  end
            end
   endtask: timeout_action_powerEnable
			
			// Handle a timeout occured when waiting for an update in discTp
  task timeout_action_discTp();
       forever begin
                 //$display("%t waiting for timeout pins comparator",$realtime);
				         events_obj.timeout_update_discTp_event.wait_trigger();
             if ( chip_status_obj.chip_status == STATUS_TESTPULSE_EXTERNAL_WORKING || chip_status_obj.chip_status == STATUS_TESTPULSE_EXTERNAL_NOTHING_HAPPENS ||
                  chip_status_obj.chip_status == STATUS_TESTPULSE_INTERNAL_WORKING || chip_status_obj.chip_status == STATUS_TESTPULSE_INTERNAL_NOTHING_HAPPENS) begin
								         `uvm_info("compare", $sformatf(":( Timeout condition for discTp update, chip_status: %s", chip_status_obj.chip_status), UVM_LOW);
				           			if ( !number_discrepancies.exists(chip_status_obj.chip_status) ) number_discrepancies[chip_status_obj.chip_status] = 1;
				              else increment_number_discrepancies();
                  end
            end
   endtask: timeout_action_discTp



endclass: CLICTD_pins_comparator



`endif // __CLICTD_pins_comparator_sv__

